#=================================VARIABLES==========================================


variables:
  DOCKER_IMAGE: $CI_REGISTRY_IMAGE
  #@---> API_NAME (string)



include:
  - project: 'models8/gitlab-ci-extensions'
    ref: master
    file: '.gitlab-ci-gitVersion.yml'



#=================================RULES============================================


.aws-deploy-staging-rule:
  rules: &aws-deploy-staging-rules
    - if: $CI_COMMIT_BRANCH =~ /staging|hotfix/

#=================================STAGES: PREPARE ============================================


get-staging-version:
  stage: versioning
  extends: .git-version
  rules:
    - *aws-deploy-staging-rules


add-git-tag:
  stage : versioning
  image:
    name: alpine/curl:3.14
    entrypoint: [ "" ]
  script:
    - 'curl --request POST --header "PRIVATE-TOKEN: $GITLAB_API_TOKEN" "https://gitlab.com/api/v4/projects/$CI_PROJECT_ID/repository/tags?tag_name=v$PACKAGE_VERSION&ref=$CI_COMMIT_SHA"'
  needs:
    - job: get-staging-version
      optional: true
      artifacts: true
  rules:
    - *aws-deploy-staging-rules


create-docker-image:
  stage: dockerizing
  image: docker:20.10
  services:
    - docker:20.10-dind
  variables:
    DOCKER_TLS_CERTDIR: ""
    DOCKER_HOST: tcp://docker:2375
  before_script:
    - cd $APPLICATION_DIR_PATH
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
  script:
    - docker build -t $DOCKER_IMAGE:$PACKAGE_VERSION .
    - docker tag $DOCKER_IMAGE:$PACKAGE_VERSION $DOCKER_IMAGE:latest
    - docker tag $DOCKER_IMAGE:$PACKAGE_VERSION $DOCKER_IMAGE:staging
    - docker push --all-tags $DOCKER_IMAGE
  tags:
    - dind
  needs:
    - job: get-staging-version
      optional: true
      artifacts: true
  rules:
    - *aws-deploy-staging-rules


#=================================STAGES: DELOY ============================================



staging-deploy-aws:  #Parent-Child pipeline
  stage: deploy
  variables:
    API_IMAGE: $DOCKER_IMAGE:$PACKAGE_VERSION
    ACTION: deploy
    ALB_HEALTHCHECK_PATH: $API_NAME/healthcheck
  trigger:
    include:
      - project: $CI_PROJECT_NAMESPACE/$REPO_NAME_TERRAFORM
        ref: production
        file: "/ci-templates/trigger-modules/.gitlab-ci-deploy-staging.yml"
    strategy: depend
  rules:
    - *aws-deploy-staging-rules
